-- require "GameLib"
require "Apollo"
require "AbilityBook"

local NPrimeActionSetMacros = {} 

function NPrimeActionSetMacros:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    return o
end

function NPrimeActionSetMacros:Init()
	Apollo.RegisterSlashCommand("ActionSetPrev", "OnActionSetPrev", self)
	Apollo.RegisterSlashCommand("ActionSetNext", "OnActionSetNext", self)
	Apollo.RegisterSlashCommand("ActionSetEnable", "OnActionSetEnable", self)
	Apollo.RegisterSlashCommand("ActionSetToggle", "OnActionSetToggle", self)
    Apollo.RegisterAddon(self)
end

function NPrimeActionSetMacros:OnActionSetPrev()
	AbilityBook.PrevSpec()
end

function NPrimeActionSetMacros:OnActionSetNext()
	AbilityBook.NextSpec()
end

function NPrimeActionSetMacros:OnActionSetEnable(strCmd, strArg)
	if (tonumber(strArg) == nil) then
		Print("[NPrimeActionSetMacros]: Invalid Action Set")
	else
		AbilityBook.SetCurrentSpec(strArg)
	end
end

function NPrimeActionSetMacros:OnActionSetToggle(strCmd, strArg)
	actionSets = {}
	for set in strArg:gmatch("%S+") do table.insert(actionSets, set) end
	if (tonumber(actionSets[1]) == nil) or (tonumber(actionSets[2]) == nil) then
		Print("[NPrimeActionSetMacros]: Invalid Action Set")
	else
		local l_actionSet1 = tonumber(actionSets[1])
		local l_actionSet2 = tonumber(actionSets[2])
		AbilityBook.SetCurrentSpec(AbilityBook.GetCurrentSpec() == l_actionSet1 and l_actionSet2 or l_actionSet1)
	end
end

local NPrimeActionSetMacrosInstance = NPrimeActionSetMacros:new()
NPrimeActionSetMacrosInstance:Init()
